// MuseView.h : interface of the CMuseView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MUSEVIEW_H__3D418091_7FA5_11D2_9F4A_1CF705C10627__INCLUDED_)
#define AFX_MUSEVIEW_H__3D418091_7FA5_11D2_9F4A_1CF705C10627__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMuseView : public CScrollView
{
protected: // create from serialization only
	CMuseView();
	void OnDrawWaveform(CDC* pDC);
	void OnDrawPitch(CDC* pDC);
	float m_fMinNote,m_fMaxNote;
	DECLARE_DYNCREATE(CMuseView)

// Attributes
public:
	CMuseDoc* GetDocument();

	// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMuseView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL
	afx_msg LRESULT OnWaveInNotify(WPARAM wParam, LPARAM lParam);

// Implementation
public:
	int m_nViewType; // 1=waveform, 2=pitch
	int m_nStep;
	BOOL m_bZCF;
	virtual ~CMuseView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMuseView)
	afx_msg void OnAnalyzeZcf();
	afx_msg void OnUpdateAnalyzeZcf(CCmdUI* pCmdUI);
	afx_msg void OnViewSlow();
	afx_msg void OnUpdateViewSlow(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewWaveform(CCmdUI* pCmdUI);
	afx_msg void OnViewWaveform();
	afx_msg void OnViewPitch();
	afx_msg void OnUpdateViewPitch(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MuseView.cpp
inline CMuseDoc* CMuseView::GetDocument()
   { return (CMuseDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MUSEVIEW_H__3D418091_7FA5_11D2_9F4A_1CF705C10627__INCLUDED_)
